commit:     7eb18730f3c700ccee7f6ff24ac44107c39a0131
Author:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
AuthorDate: Fri Feb  5 10:58:42 2021 +0000
Commit:     Lars Wendler <polynomial-c <AT> gentoo <DOT> org>
CommitDate: Fri Feb  5 10:59:30 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=7eb18730

sys-libs/libcap: Bump to version 2.48

Package-Manager: Portage-3.0.14, Repoman-3.0.2
Signed-off-by: Lars Wendler <polynomial-c <AT> gentoo.org>

 sys-libs/libcap/Manifest                           |   1 +
 .../files/libcap-2.48-build-system-fixes.patch     | 199 +++++++++++++++++++++
 sys-libs/libcap/libcap-2.48.ebuild                 |  89 +++++++++
 3 files changed, 289 insertions(+)

diff --git a/sys-libs/libcap/Manifest b/sys-libs/libcap/Manifest
index d4c82b42888..1ed10abdfee 100644
--- a/sys-libs/libcap/Manifest
+++ b/sys-libs/libcap/Manifest
@@ -1,3 +1,4 @@
 DIST libcap-2.43.tar.xz 125284 BLAKE2B 
bde36f8397f4adb74760eb403daa06bee1b8f45ddc253cc3c3ef1f6e95d0e4c76d0f2e6fa3335a8bc451f18ac7128c96230f6aba9ae0320fa4f9d669e7b4f715
 SHA512 
817add571fb2c54ad2a39974e6545b8fc8d855ecdcf2e00b2cc10e583802c49dfea2d8bca484c89ecd574fdacfc46565b51e3064a4407cf1985defb913240d45
 DIST libcap-2.46.tar.xz 129296 BLAKE2B 
22df1dcf37a920e831c47edad62df2b3e35b5360605ed24bdb9199ac8ba1fd30cd20492f8a9eae25232cc042cbef9a89a3649e0d06412b84c58f12e7795844bc
 SHA512 
6dcb249aac78efde959a986e7f06a364b2e6e57dd40b14e791d5a56012df485b2395dee0228f4cc3e1cddb2a4e3dcb9c1d83d5331ed084f23a46848494933845
 DIST libcap-2.47.tar.xz 131960 BLAKE2B 
745bd3ba9819a1582880dff81d94ccf198fcf3f89d776ac0ce3055535e5370a0be57c5efdf7287f99ed50189af14ee46e90805d0a324f92d394211ffc6d7002d
 SHA512 
cfa4aaa82b7dbb76e38cd207401603582343b14eb91d6df23e0ea6698d0ec0ab2b368fe0d08208a014a1b1a68d11316ecefa45c27983f9ad95e7b8184351fad8
+DIST libcap-2.48.tar.xz 132280 BLAKE2B 
43ab75b73a5297ec24467fae82378f8c7aba5356afcebfb32a695d664a4b5268526fd90a009596c0f516a626d8f4523a9b49ec3225b6a886da32e62eb5b55ea5
 SHA512 
3cb1e2b026c0f60d6f225c7255944d45023e59fd065b8f832739fc90d33b3347981675de12dd705c4ecbd647a494a17daf39e1d92599bcd1a83306886edadba1

diff --git a/sys-libs/libcap/files/libcap-2.48-build-system-fixes.patch 
b/sys-libs/libcap/files/libcap-2.48-build-system-fixes.patch
new file mode 100644
index 00000000000..a672ecedaca
--- /dev/null
+++ b/sys-libs/libcap/files/libcap-2.48-build-system-fixes.patch
@@ -0,0 +1,199 @@
+From d0e5c20fda92fcc48109bce7055d5fad458579ca Mon Sep 17 00:00:00 2001
+From: Mike Frysinger <vap...@gentoo.org>
+Date: Wed, 4 Nov 2020 22:46:20 +0100
+Subject: [PATCH] build system fixes
+
+This touches up the homebrewed build system to work much better "out of the
+box" for people.  Specifically:
+        - allow toolchain vars to be set via environment
+        - CC / BUILD_CC / AR / RANLIB
+        - CFLAGS / CPPFLAGS / LDFLAGS
+        - split CPPFLAGS out of CFLAGS
+        - break -fPIC out of global CFLAGS and only use where needed
+        - use LDLIBS for libraries, not LDFLAGS
+
+Signed-off-by: Mike Frysinger <vap...@gentoo.org>
+
+Forward ported from libcap-2.24 to libcap-2.25
+Forward ported from libcap-2.25 to libcap-2.28
+Forward ported from libcap-2.28 to libcap-2.29
+Forward ported from libcap-2.29 to libcap-2.33
+Forward ported from libcap-2.33 to libcap-2.34
+Forward ported from libcap-2.34 to libcap-2.37
+Forward ported from libcap-2.37 to libcap-2.39
+Forward ported from libcap-2.39 to libcap-2.42
+Forward ported from libcap-2.42 to libcap-2.44
+Forward ported from libcap-2.44 to libcap-2.45
+Forward ported from libcap-2.45 to libcap-2.48
+
+Signed-off-by: Lars Wendler <polynomia...@gentoo.org>
+---
+ Make.Rules       | 10 ++++++----
+ Makefile         |  1 -
+ libcap/Makefile  |  7 ++++---
+ pam_cap/Makefile |  8 +++++---
+ progs/Makefile   |  2 +-
+ tests/Makefile   |  6 ++++--
+ 6 files changed, 20 insertions(+), 14 deletions(-)
+
+diff --git a/Make.Rules b/Make.Rules
+index ded9014..07b716f 100644
+--- a/Make.Rules
++++ b/Make.Rules
+@@ -52,7 +52,6 @@ GOMAJOR=0
+ # Compilation specifics
+ 
+ KERNEL_HEADERS := $(topdir)/libcap/include/uapi
+-IPATH += -fPIC -I$(KERNEL_HEADERS) -I$(topdir)/libcap/include
+ 
+ CC := $(CROSS_COMPILE)gcc
+ DEFINES := -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
+@@ -60,7 +59,7 @@ COPTS ?= -O2
+ CFLAGS ?= $(COPTS) $(DEFINES)
+ BUILD_CC ?= $(CC)
+ BUILD_COPTS ?= -O2
+-BUILD_CFLAGS ?= $(BUILD_COPTS) $(DEFINES) $(IPATH)
++BUILD_CFLAGS ?= $(CFLAGS)
+ AR := $(CROSS_COMPILE)ar
+ RANLIB := $(CROSS_COMPILE)ranlib
+ DEBUG = -g #-DDEBUG
+@@ -76,10 +75,13 @@ LIBPSXLIB := -L$(topdir)/libcap -lpsx $(PSXLINKFLAGS)
+ 
+ BUILD_GPERF := $(shell which gperf >/dev/null 2>/dev/null && echo yes)
+ 
+-SYSTEM_HEADERS = /usr/include
++LIBCAP_CPPFLAGS = -I$(KERNEL_HEADERS) -I$(topdir)/libcap/include $(DEFINES)
++CPPFLAGS += $(LIBCAP_CPPFLAGS)
++BUILD_CPPFLAGS += $(LIBCAP_CPPFLAGS)
+ INCS=$(topdir)/libcap/include/sys/capability.h
+ LDFLAGS += -L$(topdir)/libcap
+-CFLAGS += -Dlinux $(WARNINGS) $(DEBUG)
++CPPFLAGS += -Dlinux
++CFLAGS += $(WARNINGS) $(DEBUG)
+ INDENT := $(shell if [ -n "$$(which indent 2>/dev/null)" ]; then echo "| 
indent -kr" ; fi)
+ 
+ # SHARED tracks whether or not the SHARED libraries (libcap.so,
+diff --git a/Makefile b/Makefile
+index 7150b9b..9dff1e9 100644
+--- a/Makefile
++++ b/Makefile
+@@ -17,7 +17,6 @@ ifeq ($(GOLANG),yes)
+       $(MAKE) -C go $@
+       rm -f cap/go.sum
+ endif
+-      $(MAKE) -C tests $@
+       $(MAKE) -C progs $@
+       $(MAKE) -C doc $@
+       $(MAKE) -C kdebug $@
+diff --git a/libcap/Makefile b/libcap/Makefile
+index 9563d88..4b42f01 100644
+--- a/libcap/Makefile
++++ b/libcap/Makefile
+@@ -25,6 +25,7 @@ MINCAPLIBNAME=$(MAJCAPLIBNAME).$(MINOR)
+ PSXOBJS=$(addsuffix .o, $(PSXFILES))
+ MAJPSXLIBNAME=$(PSXLIBNAME).$(VERSION)
+ MINPSXLIBNAME=$(MAJPSXLIBNAME).$(MINOR)
++CFLAGS += -fPIC
+ 
+ all: pcs $(STACAPLIBNAME)
+ ifeq ($(SHARED),yes)
+@@ -66,7 +67,7 @@ libpsx.pc: libpsx.pc.in
+               $< >$@
+ 
+ _makenames: _makenames.c cap_names.list.h
+-      $(BUILD_CC) $(BUILD_CFLAGS) $< -o $@
++      $(BUILD_CC) $(BUILD_CFLAGS) $(BUILD_CPPFLAGS) $< -o $@
+ 
+ cap_names.h: _makenames
+       ./_makenames > cap_names.h
+@@ -105,10 +106,10 @@ $(PSXLIBNAME) $(MAJPSXLIBNAME) $(MINPSXLIBNAME): 
$(PSXOBJS) include/sys/psx_sysc
+ endif
+ 
+ %.o: %.c $(INCLS)
+-      $(CC) $(CFLAGS) $(IPATH) -c $< -o $@
++      $(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@
+ 
+ cap_text.o: cap_text.c $(USE_GPERF_OUTPUT) $(INCLS)
+-      $(CC) $(CFLAGS) $(IPATH) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@
++      $(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDE_GPERF_OUTPUT) -c $< -o $@
+ 
+ cap_test: cap_test.c libcap.h
+       $(CC) $(CFLAGS) $(IPATH) $< -o $@
+diff --git a/pam_cap/Makefile b/pam_cap/Makefile
+index 56604fd..2da4674 100644
+--- a/pam_cap/Makefile
++++ b/pam_cap/Makefile
+@@ -3,6 +3,8 @@
+ topdir=$(shell pwd)/..
+ include ../Make.Rules
+ 
++CFLAGS += -fPIC
++
+ all: pam_cap.so
+       $(MAKE) testlink
+ 
+@@ -16,16 +18,16 @@ install: all
+ # written (and you know why it fails), email me and explain why. Thanks!
+ 
+ pam_cap.so: pam_cap.o
+-      $(LD) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS)
++      $(LD) $(CFLAGS) -o pam_cap.so $< $(LIBCAPLIB) $(LDFLAGS)
+ 
+ pam_cap.o: pam_cap.c
+-      $(CC) $(CFLAGS) $(IPATH) -c $< -o $@
++      $(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@
+ 
+ test_pam_cap: test_pam_cap.c pam_cap.c
+       $(CC) $(CFLAGS) $(IPATH) -o $@ test_pam_cap.c $(LIBCAPLIB) $(LDFLAGS) 
--static
+ 
+ testlink: test.c pam_cap.o
+-      $(CC) $(CFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)
++      $(CC) $(CFLAGS) $(CPPFLAGS) -o $@ $+ -lpam -ldl $(LIBCAPLIB) $(LDFLAGS)
+ 
+ test: pam_cap.so
+       make testlink
+diff --git a/progs/Makefile b/progs/Makefile
+index 1d7fc7a..64dbe86 100644
+--- a/progs/Makefile
++++ b/progs/Makefile
+@@ -28,7 +28,7 @@ $(BUILD): %: %.o $(DEPS)
+       $(CC) $(CFLAGS) -o $@ $< $(LIBCAPLIB) $(LDFLAGS)
+ 
+ %.o: %.c $(INCS)
+-      $(CC) $(IPATH) $(CAPSH_SHELL) $(CFLAGS) -c $< -o $@
++      $(CC) $(CAPSH_SHELL) $(CFLAGS) $(CPPFLAGS) -c $< -o $@
+ 
+ install: all
+       mkdir -p -m 0755 $(FAKEROOT)$(SBINDIR)
+diff --git a/tests/Makefile b/tests/Makefile
+index 1e7039d..5874624 100644
+--- a/tests/Makefile
++++ b/tests/Makefile
+@@ -13,6 +13,8 @@ ifeq ($(PTHREADS),yes)
+       make psx_test libcap_psx_test libcap_psx_launch_test
+ endif
+ 
++CFLAGS += -fPIC
++
+ install: all
+ 
+ ifeq ($(DYNAMIC),yes)
+@@ -62,13 +64,13 @@ run_psx_test: psx_test
+       ./psx_test
+ 
+ psx_test: psx_test.c $(DEPS)
+-      $(CC) $(CFLAGS) $(IPATH) $< -o $@ $(LINKEXTRA) $(LIBPSXLIB) $(LDFLAGS)
++      $(CC) $(CFLAGS) $(CPPFLAGS) $< -o $@ $(LINKEXTRA) $(LIBPSXLIB) 
$(LDFLAGS)
+ 
+ run_libcap_psx_test: libcap_psx_test
+       ./libcap_psx_test
+ 
+ libcap_psx_test: libcap_psx_test.c $(DEPS)
+-      $(CC) $(CFLAGS) $(IPATH) $< -o $@ $(LINKEXTRA) $(LIBCAPLIB) 
$(LIBPSXLIB) $(LDFLAGS)
++      $(CC) $(CFLAGS) $(CPPFLAGS) $< -o $@ $(LINKEXTRA) $(LIBCAPLIB) 
$(LIBPSXLIB) $(LDFLAGS)
+ 
+ # privileged
+ run_libcap_launch_test: libcap_launch_test noop ../progs/tcapsh-static
+-- 
+2.30.0
+

diff --git a/sys-libs/libcap/libcap-2.48.ebuild 
b/sys-libs/libcap/libcap-2.48.ebuild
new file mode 100644
index 00000000000..2c01dccada7
--- /dev/null
+++ b/sys-libs/libcap/libcap-2.48.ebuild
@@ -0,0 +1,89 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit multilib multilib-minimal toolchain-funcs pam usr-ldscript
+
+DESCRIPTION="POSIX 1003.1e capabilities"
+HOMEPAGE="https://sites.google.com/site/fullycapable/";
+SRC_URI="https://www.kernel.org/pub/linux/libs/security/linux-privs/libcap2/${P}.tar.xz";
+
+# it's available under either of the licenses
+LICENSE="|| ( GPL-2 BSD )"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux"
+IUSE="pam static-libs"
+
+# While the build system optionally uses gperf, we don't DEPEND on it because
+# the build automatically falls back when it's unavailable.  #604802
+RDEPEND=">=sys-apps/attr-2.4.47-r1[${MULTILIB_USEDEP}]"
+PDEPEND="pam? ( sys-libs/pam[${MULTILIB_USEDEP}] )"
+DEPEND="${RDEPEND}
+       ${PDEPEND}
+       sys-kernel/linux-headers"
+
+# Requires test suite being run as root (via sudo)
+RESTRICT="test"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-2.48-build-system-fixes.patch
+       "${FILESDIR}"/${PN}-2.38-no_perl.patch
+       "${FILESDIR}"/${PN}-2.25-ignore-RAISE_SETFCAP-install-failures.patch
+       "${FILESDIR}"/${PN}-2.21-include.patch
+)
+
+src_prepare() {
+       default
+       multilib_copy_sources
+}
+
+run_emake() {
+       local args=(
+               exec_prefix="${EPREFIX}"
+               lib_prefix="${EPREFIX}/usr"
+               lib="$(get_libdir)"
+               prefix="${EPREFIX}/usr"
+               PAM_CAP="$(usex pam yes no)"
+               DYNAMIC=yes
+               GOLANG=no
+               CC="$(tc-getCC)"
+               AR="$(tc-getAR)"
+               RANLIB="$(tc-getRANLIB)"
+       )
+       emake "${args[@]}" "$@"
+}
+
+src_configure() {
+       tc-export AR CC RANLIB
+       tc-export_build_env BUILD_CC
+       multilib-minimal_src_configure
+}
+
+multilib_src_compile() {
+       run_emake
+}
+
+multilib_src_install() {
+       # no configure, needs explicit install line #444724#c3
+       run_emake DESTDIR="${D}" install
+
+       gen_usr_ldscript -a cap
+       gen_usr_ldscript -a psx
+       if ! use static-libs ; then
+               rm "${ED}"/usr/$(get_libdir)/lib{cap,psx}.a || die
+       fi
+
+       if [[ -d "${ED}"/usr/$(get_libdir)/security ]] ; then
+               rm -r "${ED}"/usr/$(get_libdir)/security || die
+       fi
+
+       if use pam; then
+               dopammod pam_cap/pam_cap.so
+               dopamsecurity '' pam_cap/capability.conf
+       fi
+}
+
+multilib_src_install_all() {
+       dodoc CHANGELOG README doc/capability.notes
+}

Reply via email to